/*
This header is for storing the various bonuses given to a skill roll when in aid of a tool. For example,
Unlocking a lock will be easier when a set of lockpicks is used. In order for the bonus to be equal through
out the game, the bonuses are all stored in this header, in which it can be changed appropriately when
the game is balanced.

All bonuses are prepended by BONUS_ as a naming convention. The number represents the bonus towards the 
skill roll. A negative number means the tool actually makes the desired roll harder to pass.
*/

#ifndef BONUS_H
#define BONUS_H

//REPAIR BONUSES

#define BONUS_Tool					(10)
#define BONUS_Super_Tool_Kit				(20)


//LOCKPICK BONUSES

#define BONUS_Lockpicks					(10)
#define BONUS_Expanded_Lockpicks			(20)
#define BONUS_Electronic_Lockpick			(30)
#define BONUS_Electronick_Lockpick_MKII			(40)

#endif // BONUS_H