/*
	Copyright 1998-2003 Interplay Entertainment Corp.  All rights reserved.
*/

#ifndef SCRIPTS_H
#define SCRIPTS_H

/******************************************************************
   File Name: Scripts.h

   Purpose: This file contains defines for all of the scripts in
            scripts.lst. This is an ordered list and needs to
            conform exactly to scripts list. All defines in here
            need to be prepended with SCRIPT_ as a naming
            convention.

   Created: October 06, 1997
******************************************************************/

#define SCRIPT_OBJ_DUDE         (1)	//obj_dude.int   ; Player script.
#define SCRIPT_STOCKLEY         (2)	//IPSTCKLY.int   ; Stockley in COTC.
#define SCRIPT_CAPCOMP		(3)	//CapComp.int    ; Captain's Computer
#define SCRIPT_IIJUKEBX		(4)	//IIJUKEBOX.int  ; Jukebox in COTC
#define SCRIPT_DONALD		(5)	//IPDONALD.int	 ; Donald in COTC
#define SCRIPT_GENERATOR	(6)	//IGenerator.int ; Generator in Whaler.
#define SCRIPT_SUN              (7)	//Sun.int        ; Sun script. Doesn't actually exist but we need this define for the .msg file.
#define SCRIPT_IMARKET          (8)	//IMARKET.INT    ; IMarket Map script
#define SCRIPT_GENERIC          (9)	//GENERIC.INT    ; Generic Script
#define SCRIPT_ICPHIL           (10)	//icphil.int     ; Phil (City On The Coast)
#define SCRIPT_ICIKE            (11)	//icike.int      ; Ike Hogg (City On The Coast)
#define SCRIPT_ICPETE           (12)	//icpete.int     ; Pete Hogg (City On The Coast)
#define SCRIPT_ICMARIE          (13)	//icmarie.int    ; Marie Hogg (City On The Coast)
#define SCRIPT_STATMAN          (14)	//statman.int    ; The Statman!
#define SCRIPT_ISTATMAN         (15)	//istatman.int   ; Makes the Statman portable
#define SCRIPT_ICROYCE          (16)	//icroyce.int    ; Royce (City on the Coast)
#define SCRIPT_ISWHDRS          (17)	//iswhdrs.int    ; Warehouse doors in CotC
#define SCRIPT_ICWORKER         (18)	//icworker.int   ; Generic workers at Royce's (CotC)
#define SCRIPT_ISFISHBT         (19)	//isfishbt.int   ; Fishbit scenery
#define SCRIPT_ISFSHTBL         (20)	//isfshtbl.int   ; Fish table scenery
#define SCRIPT_ICSAUL           (21)	//icsaul.int	 ; Saul in CotC
#define SCRIPT_ICINI            (22)	//icini.int	 ; Ini in CotC
#define SCRIPT_ICACLYTE         (23)	//icaclyte.int   ; Generic Rat Temple Acolyte (CoTC)
#define SCRIPT_IWHALER          (24)	//IWHALER.int    ; Whaler Map script. (CoTC)
#define SCRIPT_ICFARMER         (25)	//icfarmer.int   ; Generic Farmer
#define SCRIPT_ICBOO            (26)	//icboo.int	 ; Boo (CoTC)
#define SCRIPT_ICBURRO          (27)	//icburro.int	 ; Burro (CoTC)
#define SCRIPT_ICBUTCH          (28)	//icbutch.int	 ; Butch (CoTC)
#define SCRIPT_ICDAME           (29)	//icdame.int	 ; Propaganda Dame (CoTC)
#define SCRIPT_ICFETZER         (30)	//icfetzer.int	 ; Fetzer (CoTC)
#define SCRIPT_ICFLOYD          (31)	//icfloyd.int	 ; Floyd (CoTC)
#define SCRIPT_ICFRANKLIN       (32)	//icfrnkln.int	 ; Franklin (CoTC)
#define SCRIPT_ICGALENA         (33)	//icgalena.int	 ; Galena (CoTC)
#define SCRIPT_ICGEORGE         (34)	//icgeorge.int	 ; George (CoTC)
#define SCRIPT_ICCOTCGENERIC    (35)	//icgnrc.int	 ; CoTC Generic Citizen (CoTC)
#define SCRIPT_ICHARROLD        (36)	//icharrld.int	 ; Harrold (CoTC)
#define SCRIPT_ICHEANY          (37)	//icheany.int	 ; Heany (CoTC)
#define SCRIPT_ICHOSKINS        (38)	//ichoskns.int	 ; Hoskins (CoTC)
#define SCRIPT_ICINTROWORKER    (39)	//icintwrk.int	 ; Intro Worker (CoTC)
#define SCRIPT_ICJIMMY          (40)	//icjimmy.int	 ; Jimmy (CoTC)
#define SCRIPT_ICJOTHAM         (41)	//icjotham.int	 ; Jotham (CoTC)
#define SCRIPT_ICKUNSIA         (42)	//ickunsia.int	 ; Kunsia (CoTC)
#define SCRIPT_ICLIZARDGIRL     (43)	//iclzrdgl.int	 ; Lizard Girl (CoTC)
#define SCRIPT_ICMRROBINSON     (44)	//icMrRbsn.int	 ; Mr. Robinson (CoTC)
#define SCRIPT_ICMRSROBINSON    (45)	//icMrsRbn.int	 ; Mrs. Robinson (CoTC)
#define SCRIPT_ICMITCHELL       (46)	//icmtchll.int	 ; Mitchell (CoTC)
#define SCRIPT_ICQUINN          (47)	//icquinn.int	 ; Captain Quinn (CoTC)
#define SCRIPT_ICSTOCKLEY_DAD   (48)	//icStkDad.int	 ; Stockley's Dad (CoTC???) -May need to change this name and location later.
#define SCRIPT_ICWASTER1        (49)	//icwaster1.int	 ; Waster 1 (CoTC)
#define SCRIPT_ICWASTER2        (50)	//icwaster2.int	 ; Waster 2 (CoTC)
#define SCRIPT_ICWASTER3        (51)	//icwaster3.int	 ; Waster 3 (CoTC)
#define SCRIPT_ICWASTER4        (52)	//icwaster4.int	 ; Waster 4 (CoTC)
#define SCRIPT_ICWASTER5        (53)	//icwaster5.int	 ; Waster 5 (CoTC)
#define SCRIPT_IPDAISY          (54)	//ipdaisy.int	 ; Daisy (CoTC)
#define SCRIPT_IPDOGMEAT        (55)	//ipdogmt.int	 ; Dogmeat (CoTC)
#define SCRIPT_ICMOSES          (56)	//icmoses.int	 ; Moses (CoTC)
#define SCRIPT_ICAUSTIN         (57)	//icaustin.int	 ; Austin the ranger (CoTC)
#define SCRIPT_ICBARGNRC        (58)	//icBarGnr.int   ; Generic Bar Patrons (CotC)
#define SCRIPT_ICBOB            (59)	//icBob.int	 ; Bob (CoTC)
#define SCRIPT_ICGARRY          (60)	//icGarry.int	 ; Garry (CoTC)
#define SCRIPT_ICLEIA           (61)	//icLeia.int	 ; Leia (CoTC)
#define SCRIPT_ICTENSKWATAWA    (62)	//icTensk.int	 ; Tenskwatawa (CoTC)
#define SCRIPT_ICJEREM          (63)    //icjerem.int    ; High Priest Jeremiah
#define SCRIPT_ISNCDVC		(64)    //isncdvc.int    ; The Sonic Rat Trap of the Future!

#endif // SCRIPTS_H
